144p Test Suite
===============
This ROM represents an attempt to port parts of Artemio Urbina's 240p
Test Suite to the Game Boy, as a way of learning the Game Boy CPU.

Build requirements: RGBDS, Python 3, Pillow, and GNU Make

Comparison with other ports
---------------------------
Though the NES version of 240p Test Suite uses about 52 KiB of ROM
data, the [cartridges sold by Catskull] are limited to 32 KiB.
Fortunately, the graphics for several tests are smaller than on a
240p platform.  In addition, several tests do not apply at all to a
monochrome Game Boy, allowing leaving out their help and graphics.

* Menu: Smaller portrait
* Color Bars, SMPTE Color Bars, Color Bars w/ Gray Ref
* Color Bleed Check: Replaced with forthcoming moblur and STN tests
* Linearity: Only one pixel aspect ratio (square) instead of 2 (NTSC
  and PAL), and square pixels allow calculating the grid at runtime.
  Smaller screen too.
* Sharpness: Smaller screen
* White & RGB Screen: No custom color control
* 100 IRE: Omitted
* Drop Shadow Test: Smaller portrait
* Scroll Test
* Sound Test: No music because GB doesn't support PCM

Super Game Boy and Game Boy Color enhancements are currently omitted
due to lack of ROM space and lack of time.

[cartridges sold by Catskull]: https://catskullelectronics.com/32kcart

Legal
-----
Copyright 2018 Damian Yerrick  
License: GNU GPL version 2 or later
